import { Language, IndentContext } from "@codemirror/next/language";
import { StringStream } from "./stringstream";
export { StringStream };
export interface StreamParser<State> {
    token(stream: StringStream, state: State): string | null;
    blankLine?(state: State, indentUnit: number): void;
    startState?(indentUnit: number): State;
    copyState?(state: State): State;
    indent?(state: State, textAfter: string, context: IndentContext): number | null;
    languageData?: {
        [name: string]: any;
    };
}
export declare class StreamLanguage<State> extends Language {
    private constructor();
    static define<State>(spec: StreamParser<State>): StreamLanguage<State>;
    private getIndent;
    get allowsNesting(): boolean;
}
//# sourceMappingURL=stream-parser.d.ts.map